/*
 * Cr le 12 juil. 05
 *
 * Pour changer le modle de ce fichier gnr, allez  :
 * Fentre&gt;Prfrences&gt;Java&gt;Gnration de code&gt;Code et commentaires
 */
package com.airfrance.squalecommon.datatransfertobject.transform.component;

import java.io.Serializable;

import com.airfrance.squalecommon.datatransfertobject.component.AuditDTO;
import com.airfrance.squalecommon.enterpriselayer.businessobject.component.AuditBO;

/**
 * @author M400841
 *
 * Pour changer le modle de ce commentaire de type gnr, allez  :
 * Fentre&gt;Prfrences&gt;Java&gt;Gnration de code&gt;Code et commentaires
 */
public class AuditTransform implements Serializable {

    /**
     * Constructeur prive
     */
    private AuditTransform() {

    }

    /**
     * DTO -> BO pour un Audit
     * @param pAuditDTO AuditDTO  transformer
     * @return AuditBO
     */
    public static AuditBO dto2Bo(AuditDTO pAuditDTO) {
        AuditBO auditBO = new AuditBO();

        // Initialisation des champs de auditBO

        auditBO.setId(pAuditDTO.getID());
        auditBO.setName(pAuditDTO.getName());
        auditBO.setDate(pAuditDTO.getDate());
        auditBO.setType(pAuditDTO.getType());
        auditBO.setStatus(pAuditDTO.getStatus());
        auditBO.setHistoricalDate(pAuditDTO.getHistoricalDate());
        // donnes admins
        auditBO.setMaxFileSystemSize(pAuditDTO.getMaxFileSystemSize());
        auditBO.setDuration(pAuditDTO.getDuration());
        auditBO.setRealBeginningDate(pAuditDTO.getRealBeginningDate());
        auditBO.setEndDate(pAuditDTO.getEndDate());
        auditBO.setSqualeVersion(pAuditDTO.getSqualeVersion());
        return auditBO;

    }

    /**
     * BO -> DTO pour un Audit
     * @param pAuditBO AuditBO
     * @param pApplicationId id de l'application
     * @return AuditDTO 
     */
    public static AuditDTO bo2Dto(AuditBO pAuditBO, long pApplicationId) {

        // Initialisation qui initialise la plupart des champs
        AuditDTO auditDTO = bo2Dto(pAuditBO);
        // seul champ restant  prciser
        auditDTO.setApplicationId(pApplicationId);

        return auditDTO;
    }

    /**
     * On ne spcifie pas l'id de l'audit, il sera mis plus tard car on l'a dj au moment
     * o on appelle cette mthode
     * BO -> DTO pour un Audit
     * @param pAuditBO AuditBO
     * @return AuditDTO 
     */
    public static AuditDTO bo2Dto(AuditBO pAuditBO) {
        // Initialisation
        AuditDTO auditDTO = new AuditDTO();
        // Initialisation des champs de auditBO
        auditDTO.setID(pAuditBO.getId());
        auditDTO.setName(pAuditBO.getName());
        auditDTO.setDate(pAuditBO.getDate());
        auditDTO.setType(pAuditBO.getType());
        auditDTO.setStatus(pAuditBO.getStatus());
        auditDTO.setHistoricalDate(pAuditBO.getHistoricalDate());
        // donnes admins
        auditDTO.setMaxFileSystemSize(pAuditBO.getMaxFileSystemSize());
        auditDTO.setDuration(pAuditBO.getDuration());
        auditDTO.setRealBeginningDate(pAuditBO.getRealBeginningDate());
        auditDTO.setEndDate(pAuditBO.getEndDate());
        auditDTO.setSqualeVersion(pAuditBO.getSqualeVersion());
        return auditDTO;
    }

}
