package com.airfrance.squalecommon.enterpriselayer.businessobject.config;

/**
 * Paramtre de tche
 * Une tche Squalix peut tre configure par des paramtres dynamiques,
 * ceux-ci sont dfinis dans le ficheir de configuration de squalix.
 * Un paramtre est dfini par un nom et une valeur
 * @hibernate.class 
 * table="TaskParameter"
 * lazy="true"
 */
public class TaskParameterBO {
    /**
     * Identifiant (au sens technique) de l'objet
     */
    protected long mId = -1;
    /**
     * Nom du paramtre
     */
    private String mName;
    /**
     * Valeur du paramtre
     */
    private String mValue;

    /**
     * Mthode d'accs pour mId
     * 
     * @return la l'identifiant (au sens technique) de l'objet
     * 
     * @hibernate.id generator-class="native"
     * type="long" 
     * column="TaskParameterId" 
     * unsaved-value="-1" 
     * length="19"
     * @hibernate.generator-param name="sequence" value="taskParameter_sequence" 
     * 
     */
    public long getId() {
        return mId;
    }

    /**
     * Change la valeur de mId
     * 
     * @param pId le nouvel identifiant
     */
    public void setId(long pId) {
        mId = pId;
    }

    /**
     * Mthode d'accs  mName
     * 
     * @return le nom
     * 
     * @hibernate.property 
     * name="name" 
     * column="Name" 
     * type="string" 
     * length="255"
     * not-null="true" 
     * 
     */
    public String getName() {
        return mName;
    }
    
    /**
     * 
     * @param pName nom
     */
    public void setName(String pName) {
        mName = pName;
    }
    
    
    /**
     * Mthode d'accs  mValue
     * 
     * @return la valeur
     * 
     * @hibernate.property 
     * name="name" 
     * column="Value" 
     * type="string" 
     * length="255"
     * not-null="true" 
     * 
     */
    public String getValue() {
        return mValue;
    }
    
    /**
     * 
     * @param pValue nom
     */
    public void setValue(String pValue) {
        mValue = pValue;
    }
}
