package com.airfrance.squalecommon.enterpriselayer.businessobject.result.rsm;

import com.airfrance.squalecommon.enterpriselayer.businessobject.result.IntegerMetricBO;
import com.airfrance.squalecommon.enterpriselayer.businessobject.result.MetricBO;

/**
 * @hibernate.subclass
 * discriminator-value="RSMClassMetrics"
 */
public class RSMClassMetricsBO extends RSMMetricsBO {

    /**
     * Le nombre de lignes de codes
     */
    private final static String SLOC = "sloc";

    /**
     * Les commentaires
     */
    private final static String COMMENTS = "comments";

    /**
     * Le nombre de donnes publiques
     */
    private final static String PUBLIC_DATA = "public";

    /**
     * Le nombre de donnes protges
     */
    private final static String PROTECTED_DATA = "protectedData";

    /**
     * Le nombre de donnes prives
     */
    private final static String PRIVATE_DATA = "private";

    /**
     * Constructeur par dfaut.
     */
    public RSMClassMetricsBO() {
        //super();
        getMetrics().put(SLOC, new IntegerMetricBO());
        getMetrics().put(COMMENTS, new IntegerMetricBO());
        getMetrics().put(PUBLIC_DATA, new IntegerMetricBO());
        getMetrics().put(PROTECTED_DATA, new IntegerMetricBO());
        getMetrics().put(PRIVATE_DATA, new IntegerMetricBO());
    }

    /**
     * Mthode d'accs  la mtrique SLOC
     * 
     * @return la valeur du sloc
     * 
     */
    public Integer getSloc() {
        return (Integer) ((MetricBO) getMetrics().get(SLOC)).getValue();
    }

    /**
     * Change la valeur de la mtrique SLOC
     * 
     * @param pSLOC la nouvelle valeur du SLOC
     */
    public void setSloc(Integer pSLOC) {
        ((IntegerMetricBO) getMetrics().get(SLOC)).setValue(pSLOC);
    }

    /**
     * Mthode d'accs  la mtrique SLOC
     * 
     * @return la valeur du nombre de donnes publiques
     */
    public Integer getPublicData() {
        return (Integer) ((MetricBO) getMetrics().get(PUBLIC_DATA)).getValue();
    }

    /**
     * Change la valeur de la mtrique donnes publiques
     * 
     * @param pPublic la nouvelle valeur du nombre de donnes publiques
     */
    public void setPublicData(Integer pPublic) {
        ((IntegerMetricBO) getMetrics().get(PUBLIC_DATA)).setValue(pPublic);
    }

    /**
     * Mthode d'accs  la mtrique SLOC
     * 
     * @return la valeur du nombre de donnes publiques
     */
    public Integer getProtectedData() {
        return (Integer) ((MetricBO) getMetrics().get(PROTECTED_DATA)).getValue();
    }

    /**
     * Change la valeur de la mtrique donnes protges
     * 
     * @param pProtected la nouvelle valeur du nombre de donnes protges
     */
    public void setProtectedData(Integer pProtected) {
        ((IntegerMetricBO) getMetrics().get(PROTECTED_DATA)).setValue(pProtected);
    }

    /**
     * Mthode d'accs  la mtrique nombre de donnes prives
     * 
     * @return la valeur du nombre de donnes prives
     * 
     */
    public Integer getPrivateData() {
        return (Integer) ((MetricBO) getMetrics().get(PRIVATE_DATA)).getValue();
    }

    /**
     * Change la valeur de la mtrique nombre de donnes prives
     * 
     * @param pPrivateData la nouvelle valeur du nombre de donnes prives
     */
    public void setPrivateData(Integer pPrivateData) {
        ((IntegerMetricBO) getMetrics().get(PRIVATE_DATA)).setValue(pPrivateData);
    }

    /**
     * Mthode d'accs  la mtrique commentaires
     * 
     * @return la valeur sur le nombre de lignes de commentaires
     * 
     */
    public Integer getComments() {
        return (Integer) ((IntegerMetricBO) getMetrics().get(COMMENTS)).getValue();
    }

    /**
     * Change la valeur de la mtrique commentaires
     * 
     * @param pComments la nouvelle valeur du nombre de commentaires
     */
    public void setComments(Integer pComments) {
        ((IntegerMetricBO) getMetrics().get(COMMENTS)).setValue(pComments);
    }

}
