package com.airfrance.squalecommon.enterpriselayer.businessobject.rulechecking;

import com.airfrance.squalecommon.enterpriselayer.businessobject.component.ProjectBO;

/**
 * Ensemble de rgles lies  un outil et spcifique  un projet
 * 
 * @hibernate.subclass 
 * mutable="true"
 * discriminator-value="ProjectRuleSet"
 */
public class ProjectRuleSetBO extends RuleSetBO {
    
    /** Projet sur lequel s'appliquent les rgles */
    private ProjectBO mProject;

    /**
     * @return le projet sur lequel s'appliquent les rgles
     * 
     * @hibernate.many-to-one
     * name="project" 
     * column="ProjectId" 
     * class="com.airfrance.squalecommon.enterpriselayer.businessobject.component.ProjectBO"
     * cascade="all"
     */
    public ProjectBO getProject() {
        return mProject;
    }

    /**
     * Modifie mProject
     * 
     * @param pProject le projet sur lequel s'appliquent les rgles
     */
    public void setProject(ProjectBO pProject) {
        mProject = pProject;
    }

}
