package com.airfrance.squalecommon.enterpriselayer.facade.macker;

import org.xml.sax.Attributes;

import com.airfrance.squalecommon.enterpriselayer.businessobject.rulechecking.RuleBO;
import com.airfrance.squalecommon.util.xml.FactoryAdapter;

/**
 * Factory pour les rgles
 */
public class RuleFactory extends FactoryAdapter {
    
    /** La catgorie de la rgle par dfaut */
    public static final String CATEGORY = "layerrespect";
    
    /** Le code de la rgle par dfaut */
    public static final String CODE = "Illegal reference";
    
    /** La svrit de la rgle par dfaut */
    public static final String SEVERITY = "error";

    /**
     * Cre une rgle en lui attribuant une catgorie, un code et une svrit
     * par dfaut.
     * @see org.apache.commons.digester.ObjectCreationFactory#createObject(org.xml.sax.Attributes)
     */
    public Object createObject(Attributes arg0) throws Exception {
        RuleBO rule = new RuleBO();
        rule.setCategory(CATEGORY);
        rule.setCode(CODE);
        rule.setSeverity(SEVERITY);
        return rule;
    }

}
