package com.airfrance.squalecommon.enterpriselayer.facade.pmd;

import java.io.InputStream;

import com.airfrance.squalecommon.SqualeTestCase;
import com.airfrance.squalecommon.enterpriselayer.businessobject.rulechecking.RuleBO;
import com.airfrance.squalecommon.enterpriselayer.businessobject.rulechecking.pmd.PmdRuleSetBO;

/**
 * Test du parser de configuration PMD
 */
public class PmdConfigParserTest extends SqualeTestCase {

    /**
     * Test nominal
     * On importe un fichier dont le contenu est connu, on vrifie
     * que les donnes du fichier sont restitues
     */
    public void testImportNominal() {
        StringBuffer errors = new StringBuffer();
        PmdConfigParser parser = new PmdConfigParser();
        // Parsing d'un fichier de test
        InputStream stream = getClass().getClassLoader().getResourceAsStream("data/pmd/pmd.xml");
        PmdRuleSetBO ruleset = parser.parseFile(stream, errors);
        assertEquals("pas d'erreur de parsing", 0, errors.length());
        // Vrification des donnes charges
        assertNotNull(ruleset);
        assertEquals("valeur  vrifier dans le fichier", "default",ruleset.getName());
        assertEquals("valeur  vrifier dans le fichier", "java", ruleset.getLanguage());
        // Vrification du nombre de rgles lues
        assertEquals("valeur  vrifier dans le fichier", 2, ruleset.getRules().size());
        // Vrification des attributs de la rgle CyclomaticComplexity
        RuleBO rule = (RuleBO) ruleset.getRules().get("CyclomaticComplexity");
        assertEquals("valeur  vrifier dans le fichier", "coding", rule.getCategory());
        assertEquals("valeur  vrifier dans le fichier", "CyclomaticComplexity", rule.getCode());
        assertEquals("valeur  vrifier dans le fichier", "error", rule.getSeverity());
        // Vrification des attributs de la rgle ExcessiveMethodLength
        rule = (RuleBO) ruleset.getRules().get("ExcessiveMethodLength");
        assertEquals("valeur  vrifier dans le fichier", "format", rule.getCategory());
        assertEquals("valeur  vrifier dans le fichier", "ExcessiveMethodLength", rule.getCode());
        assertEquals("valeur  vrifier dans le fichier", "warning", rule.getSeverity());
    }
}
