package com.airfrance.squaleweb.applicationlayer.formbean.component;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionMapping;

import com.airfrance.squalecommon.enterpriselayer.businessobject.component.AuditBO;
import com.airfrance.squaleweb.resources.WebMessages;
import com.airfrance.squaleweb.util.graph.GraphMaker;

/**
 * Spare les audits des applications publiques par rapport
 *  celles qui appartiennent  l'utilisateur
 */
public class SplitAuditsListForm extends AuditListForm {

    /**
     * Liste des audits sur les applications publiques
     */
    private List mPublicAudits = new ArrayList();

    /** le graph pour les stats sur la dure des audits termins */
    private GraphMaker mTimeMaker;

    /** le graph pour les stats sur la taille occupe */
    private GraphMaker mSizeMaker;

    /**
     * @return la maker
     */
    public GraphMaker getTimeMaker() {
        return mTimeMaker;
    }

    /**
     * Change le maker
     * @param pMaker le nouveau maker
     */
    public void setTimeMaker(GraphMaker pMaker) {
        mTimeMaker = pMaker;
    }

    /**
         * @return la maker
         */
    public GraphMaker getSizeMaker() {
        return mSizeMaker;
    }

    /**
     * Change le maker
     * @param pMaker le nouveau maker
     */
    public void setSizeMaker(GraphMaker pMaker) {
        mSizeMaker = pMaker;
    }

    /**
     * @return la liste des audits publiques
     */
    public List getPublicAudits() {
        return mPublicAudits;
    }

    /**
     * @param pPublicAudits la liste des audits publiques
     */
    public void setPublicAudits(List pPublicAudits) {
        mPublicAudits = pPublicAudits;
    }

    /**
     * @see org.apache.struts.action.ActionForm#reset(org.apache.struts.action.ActionMapping, javax.servlet.http.HttpServletRequest)
     * {@inheritDoc}
     */
    public void reset(ActionMapping mapping, HttpServletRequest request) {
        super.reset(mapping, request);
    }

    /** 
     * @see com.airfrance.welcom.struts.bean.WActionForm#wValidate(org.apache.struts.action.ActionMapping, javax.servlet.http.HttpServletRequest)
     * {@inheritDoc}
     */
    public void wValidate(ActionMapping pMapping, HttpServletRequest pRequest) {
        // On valide tous les audits
        for (int i = 0; i < getAudits().size(); i++) {
            AuditForm current = (AuditForm) getAudits().get(i);
            // La date ne doit pas tre nulle
            // Sauf dans le cas d'un audit de jalon programm
            if (null == current.getDate() && !(AuditBO.MILESTONE.equals(current.getType()) && AuditBO.NOT_ATTEMPTED == current.getStatus())) {
                addError("audits[" + i + "].date", new ActionError("error.date_format", WebMessages.getString(pRequest, "datetime.format.simple")));
            }
        }
    }

}
