package com.airfrance.squaleweb.applicationlayer.formbean.component.parameters;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionMapping;

import com.airfrance.squalecommon.enterpriselayer.businessobject.component.parameters.ParametersConstants;
import com.airfrance.squaleweb.applicationlayer.formbean.RootForm;

/**
 * Contient les paramtres de compilation Java pour une tche ANT ou un
 * workspace WSAD.
 */
public class JavaCompilationForm extends RootForm {

    /**
     * Type de la tche (Ant, WSAD ou RSA)
     */
    private String mKindOfTask = "";

    /*
     * *****************************************************
     * Dans le cas d'un workspace WSAD
     */
    /**
     * Chemin du workspace depuis la racine
     */
    private String mWorkspacePath = "";
    
    /*
     * Configuration supplmentaire dans le cas d'un projet RSA
     */
     
    /** Le chemin vers le manifest */
    private String mManifestPath = "";
    
    /** Le nom de l'EAR associ */ 
    private String mEarName = "";

    /*
     * *****************************************************
     * Dans le cas d'un fichier ANT
     */
    /**
     * Chemin du fichier ANT
     */
    private String mAntFile = "";
    /**
     * Tche ANT  lancer
     */
    private String mAntTaskName = "";

    /**
     * @return Chemin du fichier ANT
     */
    public String getAntFile() {
        return mAntFile;
    }

    /**
     * @return Tche ANT  lancer
     */
    public String getAntTaskName() {
        return mAntTaskName;
    }

    /**
     * @return Type de la tche (Ant ou WSAD)
     */
    public String getKindOfTask() {
        return mKindOfTask;
    }

    /**
     * @return Chemin du workspace depuis la racine
     */
    public String getWorkspacePath() {
        return mWorkspacePath;
    }

    /**
     * @param pAntFile Chemin du fichier ANT
     */
    public void setAntFile(String pAntFile) {
        mAntFile = pAntFile;
    }

    /**
     * @param pAntTaskName Tche ANT  lancer
     */
    public void setAntTaskName(String pAntTaskName) {
        mAntTaskName = pAntTaskName;
    }

    /**
     * @param pKindOfTask Nom du fichier classpath dans le projet
     */
    public void setKindOfTask(String pKindOfTask) {
        mKindOfTask = pKindOfTask;
    }

    /**
     * @param pWorkspacePath Chemin du workspace depuis la racine
     */
    public void setWorkspacePath(String pWorkspacePath) {
        mWorkspacePath = pWorkspacePath;
    }
    /** 
     * @see org.apache.struts.action.ActionForm#reset(org.apache.struts.action.ActionMapping, javax.servlet.http.HttpServletRequest)
     * {@inheritDoc}
     */
    public void reset(ActionMapping mapping, HttpServletRequest request) {
        this.mWorkspacePath = "";
        this.mAntFile = "";
        this.mAntTaskName = "";
    }
    /** 
     * @see com.airfrance.welcom.struts.bean.WActionForm#wValidate(org.apache.struts.action.ActionMapping, javax.servlet.http.HttpServletRequest)
     * {@inheritDoc}
     */
    public void wValidate(ActionMapping mapping, HttpServletRequest request) {
        if (ParametersConstants.WSAD.equals(getKindOfTask()) || ParametersConstants.RSA.equals(getKindOfTask())) {
            // Il faut que le workspace soit renseign
            // Le chemin va tre rcuprer par Squalix sous unix donc on remplace
            // ventuellement les sparateurs
            setWorkspacePath(getWorkspacePath().trim().replace('\\', '/'));
            if (getWorkspacePath().length() == 0) {
                addError("workspacePath", new ActionError("error.field.required"));
            }
        } else if(ParametersConstants.ANT.equals(getKindOfTask())) { // Il s'agit d'une rgle ant
            // Il faut que le fichier ant soit renseign
            setAntTaskName(getAntTaskName().trim());
            setAntFile(getAntFile().trim());
            if (getAntFile().length() == 0) {
                addError("antFile", new ActionError("error.field.required"));
            }
        }
        // On ajoute le nom de la tche  la requte pour indiquer au dropPanel
        // qu'il faut qu'il soit ouvert
        request.setAttribute("tool", "JCompilingTask");
    }
    /**
     * @return le nom de l'EAR associ
     */
    public String getEarName() {
        return mEarName;
    }

    /**
     * @return le chemin vers le manifest
     */
    public String getManifestPath() {
        return mManifestPath;
    }

    /**
     * @param pEarName nom de l'EAR
     */
    public void setEarName(String pEarName) {
        mEarName = (pEarName != null) ? pEarName.trim() : "";
    }

    /**
     * @param pManifestPath le chemin du manifest
     */
    public void setManifestPath(String pManifestPath) {
        mManifestPath = (pManifestPath != null) ? pManifestPath.trim() : "";
    }

}
