package com.airfrance.squaleweb.applicationlayer.formbean.messages;

import java.util.Collection;
import java.util.Date;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionMapping;

import com.airfrance.squaleweb.applicationlayer.formbean.ActionIdFormSelectable;

/**
 * 
 */
public class NewsForm extends ActionIdFormSelectable {

    /** la cl de la news */
    private String key = "";

    /** la date de dbut de validit de la news*/
    private Date beginningDate = new Date();

    /** la date de fin de validit de la news */
    private Date endDate = new Date();

    /** le form associ */
    private MessageForm message = new MessageForm();

    /**
     * Identifiant (au sens technique) de l'objet
     */
    private long mId;

    /** La liste des langues disponibles pour crire un message */
    private Collection langSet;

    /**
     * 
     * @return l'id
     */
    public long getId() {
        return mId;
    }

    /**
     * @param newId le nouvel id
     */
    public void setId(long newId) {
        mId = newId;
    }

    /**
     * @return la date de dbut de validit
     */
    public Date getBeginningDate() {
        return beginningDate;
    }

    /**
     * @return la date de fin de validit
     */
    public Date getEndDate() {
        return endDate;
    }

    /**
     * @return la cl
     */
    public String getKey() {
        return key;
    }

    /**
     * @param newBeginningDate la nouvelle date de dbut de validit
     */
    public void setBeginningDate(Date newBeginningDate) {
        beginningDate = newBeginningDate;
    }

    /**
     * @param newEndDate la nouvelle date de fin
     */
    public void setEndDate(Date newEndDate) {
        endDate = newEndDate;
    }

    /**
     * @param newTitle le nouveau titre
     */
    public void setKey(String newTitle) {
        key = newTitle;
    }

    /**
     * @return le form
     */
    public MessageForm getMessage() {
        return message;
    }

    /**
     * @param newForm la nouvelle collection
     */
    public void setMessage(MessageForm newForm) {
        message = newForm;
    }

    /**
     * @return la liste des lang
     */
    public Collection getLangSet() {
        return langSet;
    }

    /**
     * @param newLangSet la nouvelle liste des langues disponibles
     */
    public void setLangSet(Collection newLangSet) {
        langSet = newLangSet;
    }

    /**
     * @see com.airfrance.welcom.struts.bean.WActionForm#wValidate(org.apache.struts.action.ActionMapping, javax.servlet.http.HttpServletRequest)
     * {@inheritDoc}
     */
    public void wValidate(ActionMapping mapping, HttpServletRequest request) {
        // Vrification des champs obligatoire
        super.wValidate(mapping, request);
        // La cl
        setKey(getKey().trim());
        if (getKey().length() == 0) {
            addError("key", new ActionError("error.field.required"));
        }
        // Le titre du message
        getMessage().setKey("news." + getKey());
        getMessage().setTitle(getMessage().getTitle().trim());
        if (getMessage().getTitle().length() == 0) {
            addError("message.title", new ActionError("error.field.required"));
        }
        // Le message
        getMessage().setText(getMessage().getText().trim());
        if (getMessage().getText().length() == 0) {
            addError("message.text", new ActionError("error.field.required"));
        }
        getMessage().setLanguage(getMessage().getLanguage().trim());
        if (getMessage().getLanguage().length() == 0) {
            addError("message.lang", new ActionError("error.field.required"));
        }
        // Vrification de la saisie
        // La date de dbut
        if (null == getBeginningDate()) {
            addError("beginningDate", new ActionError("error.date.uncorrectFormat"));
        }
        // La date de fin
        if (null == getEndDate()) {
            addError("endDate", new ActionError("error.date.uncorrectFormat"));
        }
        // Pour grer la cohrence des dates, on vrifie que la date de fin est bien postrieure  la date de dbut
        if(getBeginningDate() != null && getEndDate() != null && getBeginningDate().getTime() > getEndDate().getTime()){
            addError("endDate", new ActionError("error.date.impossible"));
        }
    }
}
