package com.airfrance.squaleweb.applicationlayer.formbean.results;

import java.util.ArrayList;
import java.util.Collection;

import com.airfrance.squaleweb.applicationlayer.formbean.RootForm;

/**
 * Bean pour la liste des items d'une transgression
 */
public class RuleCheckingItemsListForm extends RootForm {
    
    /**
     * Nom de la rgle transgresse
     */
    private String mRuleName;

    /**
     * Dtails concernant la rgle
     */
    private Collection mDetails;
    
    /**
     * Indique si la liste contient au moins
     * un item qui possde un lien vers un composant
     */
    private boolean mComponentLink;
    
    /**
     * Constructeur par dfaut
     */
    public RuleCheckingItemsListForm() {
        mDetails = new ArrayList();
    }

    /**
     * @return le nom de la rgle
     */
    public String getRuleName() {
        return mRuleName;
    }

    /**
     * @return les dtails
     */
    public Collection getDetails() {
        return mDetails;
    }

    /**
     * @param pRuleName le nom de la rgle
     */
    public void setRuleName(String pRuleName) {
        mRuleName = pRuleName;
    }

    /**
     * @param pDetails les dtails
     */
    public void setDetails(Collection pDetails) {
        mDetails = pDetails;
    }
    /**
     * @return true si il y a un lien vers un composant
     */
    public boolean getComponentLink() {
        return mComponentLink;
    }

    /**
     * @param pComponentLink lien vers composant
     */
    public void setComponentLink(boolean pComponentLink) {
        mComponentLink = pComponentLink;
    }

}
