package com.airfrance.squaleweb.applicationlayer.formbean.results;

import com.airfrance.squaleweb.applicationlayer.formbean.ActionIdForm;

/**
 * Bean pour une transgression
 */
public class RulesCheckingForm extends ActionIdForm {
    
    /** 
     * Nom la Rgle 
     */
    protected String mNameRule;

    /**
     * La svrit de la rgle
     */
    protected String mSeverity;

    /**
     * La svrit de la rgle pour l'affichage
     */
    protected String mSeverityLang;

    /**
     * La version de grille de rgle
     */
    protected String mVersion;

    /**
     * Nombre de transgressions de la rgle
     */
    protected int mTransgressionsNumber;
    
    /**
     * Id de la mesure
     */
    protected long mMeasureID;
    
    /**
     * Constructeur par dfaut
     */
    public RulesCheckingForm() {
        mMeasureID = -1;
    }

    /**
     * @return l'id de la rgle
     */
    public long getId() {
        return mId;
    }

    /**
    * @return nom de la rgle
    */
    public String getNameRule() {
        return mNameRule;
    }

    /**
     * @return sevrit de la rgle
     */
    public String getSeverity() {
        return mSeverity;
    }

    /**
     * @return sevrit de la rgle traduite
     */
    public String getSeverityLang() {
        return mSeverityLang;
    }

    /**
     * @return le nombre de trasgression de la rgle
     */
    public int getTransgressionsNumber() {
        return mTransgressionsNumber;
    }

    /**
     * @return la version
     */
    public String getVersion() {
        return mVersion;
    }
    
    /**
     * @return l'id de la mesure
     */
    public long getMeasureID() {
        return mMeasureID;
    }

    /**
     * @param pId l'id de la rgle
     */
    public void setId(long pId) {
        mId = pId;
    }

    /**
    * @param pNameRule nom de la rgle
    */
    public void setNameRule(String pNameRule) {
        mNameRule = pNameRule;
    }

    /**
     * @param pSeverity  sevrit de la rgle
     */
    public void setSeverity(String pSeverity) {
        mSeverity = pSeverity;
    }

    /**
     * @param pSeverityLang  sevrit de la rgle traduite
     */
    public void setSeverityLang(String pSeverityLang) {
        mSeverityLang = pSeverityLang;
    }

    /**
     * @param pTrasgressionNumber  le nombre de trasgression de la rgle
     */
    public void setTransgressionsNumber(int pTrasgressionNumber) {
        mTransgressionsNumber = pTrasgressionNumber;
    }

    /**
     * @param pVersion la version
     */
    public void setVersion(String pVersion) {
        mVersion = pVersion;
    }

    /**
     * @param pID l'id de la mesure
     */
    public void setMeasureID(long pID) {
        mMeasureID = pID;
    }
}
