package com.airfrance.squaleweb.applicationlayer.tracker;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import com.airfrance.squaleweb.util.SqualeWebConstants;

/**
 * Classe grant le traitement du traceur pseudo-historique 
 */
public class Tracker {

    /** le tracker courant */
    private List mTracker;

    /**
     * Affiche le traceur
     * @param ts l'objet reprsentant l'lment courant  ajouter au traceur     
     * @param pRequest la requte HTTP.
     * @param pReset indique si on est repass par un menu auquel cas 
     * on redmarre une srie historique
     */
    public void updateHistTracker(TrackerStructure ts, HttpServletRequest pRequest, boolean pReset) {
        //test pour savoir si le traceur doit etre rinitialis ou pas,
        //il l'est si on repasse par un menu
        if (pReset) {
            this.reset(pRequest);
        }
        // on rcupre le traceur courant
        ArrayList currentTracker = (ArrayList) pRequest.getSession().getAttribute(SqualeWebConstants.TRACKER_HIST);
        mTracker = new ArrayList(0);
        if (null != currentTracker) {
            mTracker = currentTracker;
        }
        //Ajout
        // on vrifie qu'on est pas dj pass par l, 
        //si oui on ne fait que rajuster la liste du dbut jusqu'au chemin courant
        //en effaant les parcours postrieurs.
        String aux = "";
        int j;
        boolean canExit = false;
        // premier parcours ncessaire pour vrifier qu'on a pas cliqu
        // sur le traceur
        for (int i = 0; i < mTracker.size() && !canExit; i++) {
            canExit = false;
            aux = ((String) ((TrackerStructure) mTracker.get(i)).getDisplayName());
            // on est dj pass par l (typiquement on a utilis le traceur) 
            //efface les lments postrieurs en effaant l'lment courant
            // qui sera de toute faon ajout  la fin (factorisation de code)
            if (aux != null && aux.equals(ts.getDisplayName())) {
                for (j = i; j < mTracker.size();/* la taille diminue par le remove*/) {
                    mTracker.remove(j);
                }
               canExit = true;
            }
        }
        // si a ne vient pas du traceur
        if(!canExit){
            for (int i = 0; i < mTracker.size() && !canExit; i++) {
                newTrackerAccessWay(ts,i);
            }
        }
        // rajuste la liste 
        ((ArrayList)mTracker).trimToSize();
        //on ajoute l'lment courant         
        mTracker.add(ts);
        pRequest.getSession().setAttribute(SqualeWebConstants.TRACKER_HIST, mTracker);
    }
    
    /**
     * une mthode qui met  jour le tracker pour un chemin indit
     * @param pTs la Structure du tracker
     * @param pIndex la position de l'lment courant compar dans le tracker courant
     */
    private void newTrackerAccessWay(TrackerStructure pTs,int pIndex) {
        boolean canExit = false;
        // les lments n'ont pas le type indfini mais ont le meme type 
        if (pTs.getType() != TrackerStructure.UNDEFINED && pTs.getType() == ((TrackerStructure) mTracker.get(pIndex)).getType()) {
            //il faut vrifier qu'il y a dj un lment d'un autre type prsent 
            // sinon on efface lors de facteurs-criteres-pratiques...
            // car facteur et pratique ont le meme type
            if (pTs.getType() == TrackerStructure.FACTOR_VIEW) {
                for (int j = mTracker.size() - 1; j > -1; j--) {
                    if (TrackerStructure.COMPONENT_VIEW == ((TrackerStructure) mTracker.get(j)).getType()) {
                        //on doit vrifier qu'il y a aussi un element de type facteur view dja prsent
                        //pour le cas o on passe par les tops
                        for (int k = j - 1; k > -1  && !canExit; k--) {
                            if (TrackerStructure.FACTOR_VIEW == ((TrackerStructure) mTracker.get(k)).getType()) {
                                //si oui, on peut tout effacer
                                while (j > -1) {
                                    mTracker.remove(j--);
                                }
                                canExit = true;
                            }
                        }
                    }
                }
            }
        }
    }

    /**
     * @param pRequest la requte http
     */
    public void reset(HttpServletRequest pRequest) {
        pRequest.getSession().setAttribute(SqualeWebConstants.TRACKER_RESET, "false");
        pRequest.getSession().setAttribute(SqualeWebConstants.TRACKER_HIST, new ArrayList());
        pRequest.getSession().setAttribute(SqualeWebConstants.TRACKER_COMPONENT, new ArrayList());
    }

}