/*
 * Cr le 6 sept. 05, par m400832.
 */
package com.airfrance.squalix.tools.clearcase.utility;

import com.airfrance.squalix.tools.clearcase.configuration.ClearCaseConfiguration;


/**
 * @author m400832
 * @version 1.0
 */
public class ClearCaseStringCleaner {

    /**
     * Cette mthode retourne une chane en minuscules, sans caractres spciaux ; 
     * i.e. uniquement des lettres, des chiffres et des "<code>_</code>" 
     * (qui est utilis comme caractre de remplacement).<br />
     * Typiquement :<br /><pre>
     * a0~&1245cacahues ' hihi#{((ldkqsmiopnncwx,ncxcwx)\\|-||
     * </pre> deviendra : <br /><pre>
     * a0__________1245cacahu_es___hihi____ldkqsmiopnncwx_ncxcwx______
     * </pre>
     * @param pStringToBeCleaned chane  nettoyer.
     * @return la chane nettoye.
     */
    public static String getCleanedStringFrom(String pStringToBeCleaned) {
        StringBuffer tmp = new StringBuffer();
        char car;
        
        int i=0;
        /* tant que l'on est pas arriv au bout de la chane */
        while(i < pStringToBeCleaned.length()){
            
            /* on rcupre le caractre  traiter */
            car = pStringToBeCleaned.charAt(i);
            
            /* s'il s'agit d'un caractre spcial et/ou accentu */
            if(Character.isJavaIdentifierPart(car) && 
                Character.getNumericValue(car) >= 0) {
                    
                tmp.append(car);
            /* sinon */
            } else { 
                tmp.append(ClearCaseConfiguration.UNDERSCORE);
            }
            i++;
        }
        
        /* on retourne la chane nettoye */
        return tmp.toString().toLowerCase();
    }
}
