/*
 * $Id: PrintXmlResults.java 8 2008-02-21 16:01:23Z bellingard $
 *
 * (C) Copyright 2005 Diomidis Spinellis, Julien Rentrop
 *
 * Permission to use, copy, and distribute this software and its documentation
 * for any purpose and without fee is hereby granted, provided that the above
 * copyright notice appear in all copies and that both that copyright notice and
 * this permission notice appear in supporting documentation.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */
package gr.spinellis.ckjm.ant;

import gr.spinellis.ckjm.CkjmOutputHandler;
import gr.spinellis.ckjm.ClassMetrics;

import java.io.PrintStream;

/**
 * XML output formatter
 *
 * @author Julien Rentrop
 */
public class PrintXmlResults implements CkjmOutputHandler {
    
    /** printer */
    private PrintStream p;

    /**
     * @param printer the printer
     */
    public PrintXmlResults(PrintStream printer) {
        this.p = printer;
    }

    /**
     * print xml header
     */
    public void printHeader() {
        p.println("<?xml version=\"1.0\"?>");
        p.println("<ckjm>");
    }

    /**
     * Write metrics information
     * @see gr.spinellis.ckjm.CkjmOutputHandler#handleClass(java.lang.String, gr.spinellis.ckjm.ClassMetrics)
     */
    public void handleClass(String name, ClassMetrics c) {
        p.print("<class>\n" +
                "<name>" + name + "</name>\n" +
                "<wmc>" + c.getWmc() + "</wmc>\n" +
                "<dit>" + c.getDit() + "</dit>\n" +
                "<noc>" + c.getNoc() + "</noc>\n" +
                "<cbo>" + c.getCbo() + "</cbo>\n" +
                "<rfc>" + c.getRfc() + "</rfc>\n" +
                "<lcom>" + c.getLcom() + "</lcom>\n" +
                "<ca>" + c.getCa() + "</ca>\n" +
                "<npm>" + c.getNpm() + "</npm>\n" +
                "</class>\n");
    }

    /**
     * print xml footer
     */
    public void printFooter () {
        p.println("</ckjm>");
    }
}
