package gr.spinellis.ckjm;

import gr.spinellis.ckjm.ant.PrintXmlResults;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.Enumeration;
import java.util.jar.JarEntry;
import java.util.jar.JarFile;
import java.util.zip.ZipFile;

import junit.framework.TestCase;

/**
 * Test pour MetricsFilter
 */
public class MetricsFilterTest extends TestCase {

    private static final String PLAIN_FILE_NAME = "TestMetricsFilterPlain.txt";
    
    private static final String XML_FILE_NAME = "TestMetricsFilterXml.xml";

    private static final String CLASSES_DIR_PATH = "bin/gr/spinellis/ckjm";


    /**
     * Constructeur
     * @param arg0 nom
     */
    public MetricsFilterTest(String arg0) {
        super(arg0);
    }

    /**
     * @throws FileNotFoundException
     */
    public void testRunMetricsPlain() throws IOException {
        File outputFile = new File(PLAIN_FILE_NAME);
        assertFalse(outputFile.exists());
        OutputStream outputStream = new FileOutputStream(outputFile);
        PrintPlainResults outputPlain = new PrintPlainResults(
                                    new PrintStream(outputStream));
        File classDir = new File(CLASSES_DIR_PATH);
        String[] files = classDir.list();
        for (int i = 0; i < files.length; i++) {
            files[i] = classDir.getPath() + File.separatorChar + files[i];
        }
        MetricsFilter.runMetrics(files, outputPlain);
        assertTrue(outputFile.exists());
        outputStream.close();
        outputFile.delete();
    }

    /**
     * @throws FileNotFoundException
     */
    public void testRunMetricsXML() throws IOException {
        File outputFile = new File(XML_FILE_NAME);
        assertFalse(outputFile.exists());
        OutputStream outputStream = new FileOutputStream(outputFile);
        PrintXmlResults outputXml = new PrintXmlResults(
                                    new PrintStream(outputStream));
        File classDir = new File(CLASSES_DIR_PATH);
        String[] files = classDir.list();
        for (int i = 0; i < files.length; i++) {
            files[i] = classDir.getPath() + File.separatorChar + files[i];
        }
        MetricsFilter.runMetrics(files, outputXml);
        outputXml.printFooter();
        assertTrue(outputFile.exists());
        outputStream.close();
        outputFile.delete();
    }
}
