package com.airfrance.squaleide.popup.actions;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IObjectActionDelegate;

import com.airfrance.squaleide.util.MarkerHelpers;
import com.airfrance.squaleide.util.messages.PluginMessages;

/**
 * Supprime un plan d'action SQUALE
 */
public class RemovePlanAction extends BasicPlanAction implements IObjectActionDelegate {

    /**
     * Constructeur par dfaut
     */
    public RemovePlanAction() {
        super();
    }
    
    /** 
     * Supprime le plan d'action SQUALE du projet
     * @param action {@inheritDoc}
     * @see org.eclipse.ui.IActionDelegate#run(org.eclipse.jface.action.IAction)
     */
    public void run(IAction action) {
        Shell shell = new Shell();
        String dialogTitle = PluginMessages.getString("dialog.title");
        String confirmationMsg = PluginMessages.getString("remove.confirme");
        if (MessageDialog.openConfirm(shell, dialogTitle, confirmationMsg)) {
            try {
                MarkerHelpers.removeMarker(project);
            } catch (CoreException e) {
                openError(shell, "remove.error", e);
            }
        }
    }

}
